﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Web.Services;
using System.Web.Script.Services;

namespace PureChat.Plugins.OnTime
{
	[WebService(Namespace = "http://www.axosoft.com/PureChat/Plugins/OnTime/")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[ScriptService]
	public class OnTimePluginService : System.Web.Services.WebService
	{
		public static Settings Settings;
		
		[WebMethod]
		public bool AddCustomer(string companyName, string url)
		{
			using (OnTimeSDK.Customer.CustomerHandler customerHandler = new PureChat.Plugins.OnTimeSDK.Customer.CustomerHandler(Settings.CustomerServiceUrl))
			{
				OnTimeSDK.Customer.Customer customer = new PureChat.Plugins.OnTimeSDK.Customer.Customer();

				#region Copy Default Permissions

				//get the new customer defaults customer first
				OnTimeSDK.Customer.Customer newDefaultsCustomer = customerHandler.GetCustomerByCustomerId(Settings.SecurityGuid, -201);

				if (newDefaultsCustomer != null)
				{
					customer.DefectAddEditProjectId = newDefaultsCustomer.DefectAddEditProjectId;
					customer.DefectViewFilterId = newDefaultsCustomer.DefectViewFilterId;
					customer.DefectViewProjectId = newDefaultsCustomer.DefectViewProjectId;

					customer.FeatureAddEditProjectId = newDefaultsCustomer.FeatureAddEditProjectId;
					customer.FeatureViewFilterId = newDefaultsCustomer.FeatureViewFilterId;
					customer.FeatureViewProjectId = newDefaultsCustomer.FeatureViewProjectId;

					customer.IncidentAddEditProjectId = newDefaultsCustomer.IncidentAddEditProjectId;
					customer.IncidentViewFilterId = newDefaultsCustomer.IncidentViewFilterId;
					customer.IncidentViewProjectId = newDefaultsCustomer.IncidentViewProjectId;

					customer.WikiPageViewProjectId = newDefaultsCustomer.WikiPageViewProjectId;
					customer.WikiPageAddEditProjectId = newDefaultsCustomer.WikiPageAddEditProjectId;
				}

				#endregion

				customer.CompanyName = companyName;
				customer.CompanyURL = url;
				customerHandler.AddCustomer(Settings.SecurityGuid, customer);
			}
			return true;
		}

		[WebMethod]
		public CustomerSearchResult AddCustomerContact(string firstName, string lastName, string email, int customerId, string companyName)
		{
			using (OnTimeSDK.Customer.CustomerHandler customerHandler = new PureChat.Plugins.OnTimeSDK.Customer.CustomerHandler(Settings.CustomerServiceUrl))
			{
				OnTimeSDK.Customer.CustomerContact contact = new PureChat.Plugins.OnTimeSDK.Customer.CustomerContact();

				#region Copy Default Permissions
				
				//get the new customer defaults customer contact first
				OnTimeSDK.Customer.CustomerContact newDefaultsCustomerContact = customerHandler.GetCustomerContactByCustomerContactId(Settings.SecurityGuid, -201);

				if (newDefaultsCustomerContact != null)
				{
					contact.AllowDefectAddAttachmentOwn = newDefaultsCustomerContact.AllowDefectAddAttachmentOwn;
					contact.AllowDefectAddAttachmentPublic = newDefaultsCustomerContact.AllowDefectAddAttachmentPublic;
					contact.AllowDefectAdd = newDefaultsCustomerContact.AllowDefectAdd;
					contact.AllowDefectEditOwn = newDefaultsCustomerContact.AllowDefectEditOwn;
					contact.AllowDefectEditPublic = newDefaultsCustomerContact.AllowDefectEditPublic;
					contact.AllowDefectViewAttachmentOwn = newDefaultsCustomerContact.AllowDefectViewAttachmentOwn;
					contact.AllowDefectViewAttachmentPublic = newDefaultsCustomerContact.AllowDefectViewAttachmentPublic;
					contact.AllowDefectViewPublic = newDefaultsCustomerContact.AllowDefectViewPublic;
					contact.AllowDefectViewOwn = newDefaultsCustomerContact.AllowDefectViewOwn;
					contact.IncludeCompanyDefects = newDefaultsCustomerContact.IncludeCompanyDefects;

					contact.AllowFeatureAddAttachmentOwn = newDefaultsCustomerContact.AllowFeatureAddAttachmentOwn;
					contact.AllowFeatureAddAttachmentPublic = newDefaultsCustomerContact.AllowFeatureAddAttachmentPublic;
					contact.AllowFeatureAdd = newDefaultsCustomerContact.AllowFeatureAdd;
					contact.AllowFeatureEditOwn = newDefaultsCustomerContact.AllowFeatureEditOwn;
					contact.AllowFeatureEditPublic = newDefaultsCustomerContact.AllowFeatureEditPublic;
					contact.AllowFeatureViewAttachmentOwn = newDefaultsCustomerContact.AllowFeatureViewAttachmentOwn;
					contact.AllowFeatureViewAttachmentPublic = newDefaultsCustomerContact.AllowFeatureViewAttachmentPublic;
					contact.AllowFeatureViewPublic = newDefaultsCustomerContact.AllowFeatureViewPublic;
					contact.AllowFeatureViewOwn = newDefaultsCustomerContact.AllowFeatureViewOwn;
					contact.IncludeCompanyFeatures = newDefaultsCustomerContact.IncludeCompanyFeatures;

					contact.AllowIncidentAddAttachmentOwn = newDefaultsCustomerContact.AllowIncidentAddAttachmentOwn;
					contact.AllowIncidentAddAttachmentPublic = newDefaultsCustomerContact.AllowIncidentAddAttachmentPublic;
					contact.AllowIncidentAdd = newDefaultsCustomerContact.AllowIncidentAdd;
					contact.AllowIncidentEditOwn = newDefaultsCustomerContact.AllowIncidentEditOwn;
					contact.AllowIncidentEditPublic = newDefaultsCustomerContact.AllowIncidentEditPublic;
					contact.AllowIncidentViewAttachmentOwn = newDefaultsCustomerContact.AllowIncidentViewAttachmentOwn;
					contact.AllowIncidentViewAttachmentPublic = newDefaultsCustomerContact.AllowIncidentViewAttachmentPublic;
					contact.AllowIncidentViewPublic = newDefaultsCustomerContact.AllowIncidentViewPublic;
					contact.AllowIncidentViewOwn = newDefaultsCustomerContact.AllowIncidentViewOwn;
					contact.IncludeCompanyIncidents = newDefaultsCustomerContact.IncludeCompanyIncidents;

					contact.Settings = new PureChat.Plugins.OnTimeSDK.Customer.CustomerContactSettings();

					contact.Settings.PageSize = newDefaultsCustomerContact.Settings.PageSize;

					contact.AllowAddPublicWikiPages = newDefaultsCustomerContact.AllowAddPublicWikiPages;
					contact.AllowEditPublicWikiPages = newDefaultsCustomerContact.AllowEditPublicWikiPages;
					contact.AllowViewPublicWikiPages = newDefaultsCustomerContact.AllowViewPublicWikiPages;
					contact.AllowAddWikiAttachments = newDefaultsCustomerContact.AllowAddWikiAttachments;
				}

				#endregion

				contact.FirstName = firstName;
				contact.LastName = lastName;
				contact.Email = email;
				contact.CustomerId = customerId;

				contact.CustomerContactId = customerHandler.AddCustomerContact(Settings.SecurityGuid, contact);

				return new CustomerSearchResult(contact.CustomerContactId, companyName, firstName, lastName, email);
			}
		}

		[WebMethod]
		public string SearchCustomers(string searchTerm)
		{
			List<CustomerSearchResult> results = new List<CustomerSearchResult>();

			using (OnTimeSDK.Customer.CustomerHandler handler = new PureChat.Plugins.OnTimeSDK.Customer.CustomerHandler(Settings.CustomerServiceUrl))
			{
				using (DataSet ds = handler.SearchCustomers(Settings.SecurityGuid, searchTerm))
				{
					foreach (DataRow dr in ds.Tables[0].Rows)
					{
						if (string.IsNullOrEmpty(searchTerm) || (bool)dr["CustomerIsMatch"])
							results.Add(new CustomerSearchResult((int)dr["CustomerId"], dr["CompanyName"].ToString(), string.Empty, string.Empty, string.Empty));
					}
				}
			}

			using (System.Web.UI.WebControls.GridView gv = CreateGridView("customersSearchGridView", "No customers match your search."))
			{
				gv.Columns.Add(CreateBoundField("CustomerName", "Company"));

				System.Web.UI.WebControls.ButtonField bf = new System.Web.UI.WebControls.ButtonField();
				bf.ButtonType = System.Web.UI.WebControls.ButtonType.Link;
				bf.Text = "Select";
				bf.CommandName = "Select";
				bf.HeaderText = string.Empty;
				bf.ControlStyle.CssClass = "OnTimePlugin_Grid_Link";
				gv.Columns.Add(bf);
				gv.RowDataBound += delegate(object sender, System.Web.UI.WebControls.GridViewRowEventArgs e)
				{
					if (e.Row.RowType != System.Web.UI.WebControls.DataControlRowType.DataRow)
						return;

					System.Web.UI.WebControls.LinkButton lb = (System.Web.UI.WebControls.LinkButton)e.Row.Cells[gv.Columns.Count - 1].Controls[0];
					CustomerSearchResult result = (CustomerSearchResult)e.Row.DataItem;
					lb.OnClientClick = string.Format("selectCustomerSearchResult('{0}', '{1}'); return false;", result.ContactId, result.CustomerName);
				};

				gv.DataSource = results;
				gv.DataBind();
				return RenderWebControl(gv);
			}
		}

		[WebMethod]
		public string SearchCustomerContacts(string searchTerm)
		{
			List<CustomerSearchResult> results = new List<CustomerSearchResult>();

			using (OnTimeSDK.Customer.CustomerHandler handler = new PureChat.Plugins.OnTimeSDK.Customer.CustomerHandler(Settings.CustomerServiceUrl))
			{
				using (DataSet ds = handler.SearchCustomers(Settings.SecurityGuid, searchTerm))
				{
					/*
Table 0
CustomerId
CompanyName
CompanyURL
CustomerIsMatch
MatchingContacts
TotalContacts
ContactsOnPreviousPage

Table 1
CustomerContactId
CustomerId
FirstName
LastName
Email
ContactIsMatch
					*/
					foreach (DataRow dr in ds.Tables[1].Rows)
					{
						if (string.IsNullOrEmpty(searchTerm) || (bool)dr["ContactIsMatch"])
							results.Add(new CustomerSearchResult((int)dr["CustomerContactId"], dr.GetParentRow(ds.Relations[0])["CompanyName"].ToString(), dr["FirstName"].ToString(), dr["LastName"].ToString(), dr["Email"].ToString()));
					}
				}
			}

			using (System.Web.UI.WebControls.GridView gv = CreateGridView("customerContactsSearchGridView", "No customers match your search."))
			{
				gv.Columns.Add(CreateBoundField("CustomerName", "Company"));
				gv.Columns.Add(CreateBoundField("ContactFirstName", "First"));
				gv.Columns.Add(CreateBoundField("ContactLastName", "Last"));

				System.Web.UI.WebControls.ButtonField bf = new System.Web.UI.WebControls.ButtonField();
				bf.ButtonType = System.Web.UI.WebControls.ButtonType.Link;
				bf.Text = "Select";
				bf.CommandName = "Select";
				bf.HeaderText = string.Empty;
				bf.ControlStyle.CssClass = "OnTimePlugin_Grid_Link";
				gv.Columns.Add(bf);
				gv.RowDataBound += delegate(object sender, System.Web.UI.WebControls.GridViewRowEventArgs e)
				{
					if (e.Row.RowType != System.Web.UI.WebControls.DataControlRowType.DataRow)
						return;

					System.Web.UI.WebControls.LinkButton lb = (System.Web.UI.WebControls.LinkButton)e.Row.Cells[gv.Columns.Count - 1].Controls[0];
					CustomerSearchResult result = (CustomerSearchResult)e.Row.DataItem;
					lb.OnClientClick = string.Format("selectCustomerContactSearchResult('{0}', '{1}'); return false;", result.ContactId, result.ContactDisplayName);
				};

				gv.DataSource = results;
				gv.DataBind();
				return RenderWebControl(gv);
			}
		}

		private static System.Web.UI.WebControls.GridView CreateGridView(string id, string emptyText)
		{
			System.Web.UI.WebControls.GridView gv = new System.Web.UI.WebControls.GridView();
			gv.ID = id;
			gv.AlternatingRowStyle.CssClass = "OnTimePlugin_Grid_AltRow";
			gv.RowStyle.CssClass = "OnTimePlugin_Grid_Row";
			gv.CssClass = "OnTimePlugin_Grid";
			gv.HeaderStyle.CssClass = "OnTimePlugin_Grid_HeaderRow";
			gv.EmptyDataText = emptyText;
			gv.AutoGenerateColumns = false;
			gv.PageSize = 200;
			gv.AllowPaging = false;
			gv.AllowSorting = false;
			gv.EnableViewState = false;
			gv.ShowFooter = false;

			return gv;
		}

		private static System.Web.UI.WebControls.BoundField CreateBoundField(string dataField, string headerText)
		{
			return CreateBoundField(dataField, headerText, null);
		}

		private static System.Web.UI.WebControls.BoundField CreateBoundField(string dataField, string headerText, string formatString)
		{
			System.Web.UI.WebControls.BoundField bf = new System.Web.UI.WebControls.BoundField();
			bf.DataField = dataField;
			bf.HeaderText = headerText;
			if (!string.IsNullOrEmpty(formatString))
				bf.DataFormatString = formatString;
			return bf;
		}

		private static string RenderWebControl(System.Web.UI.WebControls.WebControl control)
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			using (System.IO.StringWriter sw = new System.IO.StringWriter(sb))
			{
				using (System.Web.UI.HtmlTextWriter tw = new System.Web.UI.HtmlTextWriter(sw))
				{
					control.RenderControl(tw);
				}
			}

			return sb.ToString();
		}
	}

	[Serializable]
	public sealed class CustomerSearchResult
	{
		public int ContactId;
		public string CustomerName;
		public string ContactFirstName;
		public string ContactLastName;
		public string ContactEmailAddress;
		public string ContactDisplayName;

		public CustomerSearchResult()
		{
		}

		public CustomerSearchResult(int contactId, string customerName, string contactFirstName, string contactLastName, string contactEmailAddress)
		{
			ContactId = contactId;
			CustomerName = customerName;
			ContactFirstName = contactFirstName;
			ContactLastName = contactLastName;
			ContactEmailAddress = contactEmailAddress;
			ContactDisplayName = GetCustomerName().Replace("'", "''");
		}

		private string GetCustomerName()
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			if (!string.IsNullOrEmpty(ContactFirstName))
			{
				sb.Append(ContactFirstName);
				sb.Append(" ");
			}
			if (!string.IsNullOrEmpty(ContactLastName))
			{
				sb.Append(ContactLastName);
				sb.Append(" ");
			}
			if (!string.IsNullOrEmpty(CustomerName))
				sb.AppendFormat("({0})", CustomerName);

			return sb.ToString().Trim();
		}
	}
}
